{% extends "ajax/soul/shell.html.twig" %}
{% block soul_content %}
    <div class="row">
        <div class="cell rw-12 padded">
            {# @var payload \App\Structures\TwinoidPayload #}
            {% if preview %}
                <div class="note">
                    <b>{{ 'Hurra, wir haben dein Profil heruntergeladen!'|trans({},'soul') }}</b>
                    {{ 'Bitte prüfe die unten angegebenen Daten und bestätige den Import, wenn alles OK ist.'|trans({},'soul') }}
                </div>

                <h5>{{ 'Informationen über dein Twinoid-Konto'|trans({},'soul') }}</h5>
                <div class="help">
                    {{ 'Bitte stelle sicher, dass du das korrekte Twinoid-Konto mit deinem MyHordes-Account verbindest.'|trans({},'soul') }}
                    <b>{{ 'Einmal bestätigt, kann die Verknüpfung nicht mehr aufgehoben werden und du kannst kein anderes Twinoid-Konto mehr verknüpfen.'|trans({},'soul') }}</b>
                    {{ 'Du kannst natürlich weiterhin Konten von Hordes, DieVerdammten, Die2Nite und Zombinoia importieren, welche mit dem selben Twinoid-Konto verbunden sind.'|trans({},'soul') }}
                </div>

                <div class="row">
                    <div class="padded cell rw-4"><b>{{ 'Twinoid-Profil'|trans({},'soul') }}</b></div>
                    <div class="padded cell rw-8">{{ payload.twinoidName }}</div>
                    <div class="padded cell ro-4 rw-8"><a target="_blank" href="https://twinoid.com/user/{{ payload.twinoidId }}"><i class="fa fa-external-link-alt"></i> {{ 'Profil ansehen'|trans({},'soul') }}</a></div>
                    <div class="padded cell rw-4"><b>{{ 'Seelen-ID'|trans({},'soul') }}</b></div>
                    <div class="padded cell rw-8">{{ payload.scopeId }}</div>
                </div>
            {% endif %}
            <h5>{{ 'Zusammenfassung'|trans({},'soul') }}</h5>
            <div class="dashboard">
                <div class="row">
                    <div class="padded cell rw-6 rw-sm-12 center">

                        {% if payload.pastTowns|length > 0 %}
                            <div class="counter">{{ '{c} Städte'|trans({'{c}': payload.pastTowns|length}, 'soul') }}</div>

                            {% set rg  = [-1,-1] %}
                            {% set new = 0 %}
                            {% set old = 0 %}
                            {% for town in payload.pastTowns %}
                                {% if not town.old %}
                                    {% set new = new+1 %}
                                    {% if rg[0] < 0 %} {% set rg = [town.season,rg[1]] %} {% else %} {% set rg = [min( rg[0],town.season ),rg[1]] %} {% endif %}
                                    {% if rg[1] < 0 %} {% set rg = [rg[0],town.season] %} {% else %} {% set rg = [rg[0],max( rg[1],town.season )] %} {% endif %}
                                {% else %}
                                    {% set old = old+1 %}
                                {% endif %}
                            {% endfor %}
                            {% if new > 0 %}
                                {% if new == payload.pastTowns|length %}
                                    <div><em>{{ 'zwischen Saison {smin} und {smax}'|trans({'{smin}': rg[0],'{smax}': rg[1]},'soul') }}</em></div>
                                {% else %}
                                    <div><em>{{ '{num} Städte zw. Saison {smin} und {smax}'|trans({'{num}': new,'{smin}': rg[0],'{smax}': rg[1]},'soul') }}</em></div>
                                {% endif %}
                            {% endif %}
                            {% if old > 0 %}
                                {% if old == payload.pastTowns|length %}
                                    <div><em>{{ 'aus vergangener Zeit'|trans({},'soul') }}</em></div>
                                {% else %}
                                    <div><em>{{ '{num} Städte aus vergangener Zeit'|trans({'{num}': old},'soul') }}</em></div>
                                {% endif %}
                            {% endif %}
                        {% else %}
                            <div class="counter">{{ 'Keine Städte'|trans({}, 'soul') }}</div>
                        {% endif %}
                    </div>
                    <div class="padded cell rw-6 rw-sm-12 center">
                        {% if payload.unlockables|length > 0 %}
                            {% set title   = 0 %}
                            {% set icon    = 0 %}
                            {% set unknown = 0 %}
                            {% for unlockable in payload.unlockables %}
                                {% if unlockable.type == 'title' %}
                                    {% set title = title+1 %}
                                {% elseif unlockable.type == 'icon' %}
                                    {% set icon = icon+1 %}
                                {% else %}
                                    {% set unknown = unknown+1 %}
                                {% endif %}
                            {% endfor %}

                            <div class="counter">{{ '{c} Titel & Icons'|trans({'{c}': payload.unlockables|length}, 'soul') }}</div>
                            <div><em>{{ '{c} Titel, {cc} Icons'|trans({'{c}': title, '{cc}': icon},'soul') }}</em></div>

                            {% if unknown > 0 %}
                                <div><em><img alt="" src="{{ asset('build/images/icons/small_warning.gif') }}" /> {{ '{num} unbekannte Objekte!'|trans({'{num}': unknown},'soul') }}</em></div>
                            {% endif %}
                        {% else %}
                            <div class="counter">{{ 'Keine Freischaltungen'|trans({}, 'soul') }}</div>
                        {% endif %}
                    </div>
                </div>

            </div>

            <div class="green-note">
                {% if not select_main_soul and main_soul %}
                    <b>{{ 'Dies ist deine Hauptseele.'|trans({},'soul') }}</b>
                    {% if limited %}
                        {{ 'In der Vergangenheit importierte Seelenpunkte, Auszeichnungen und Heldenerfahrung von dieser Seele sind deinem MyHordes-Profil gutgeschrieben worden. Neu hinzu gekommene Seelenpunkte, Auszeichnungen und Heldenerfahrung werden jedoch nur in einem gesonderten Bereich deiner Seele angezeigt.'|trans({},'soul') }}
                    {% else %}
                        {{ 'Seelenpunkte, Auszeichnungen und Heldenerfahrung von dieser Seele können in dein MyHordes-Profil importiert werden.'|trans({},'soul') }}
                    {% endif %}
                {% elseif not select_main_soul and not main_soul %}
                    <b>{{ 'Dies ist nicht deine Hauptseele.'|trans({},'soul') }}</b> {{ 'Seelenpunkte, Auszeichnungen und Heldenerfahrung können nur von deiner Hauptseele in dein MyHordes-Profil importiert werden.'|trans({},'soul') }}
                {% else %}
                    <img alt="" src="{{ asset('build/images/icons/small_hero_up.gif') }}">  <b>{{ 'Möchtest du diese Seele zu deiner Hauptseele erklären?'|trans({},'soul') }}</b>
                    {% if limited %}
                        <p>{{ 'Hiermit markierst du die Seele, mit der du dich am meisten identifizierst. Es kann nur eine importierte Seele zur Hauptseele erklärt werden. Überlege dir deine Entscheidung gut, denn du kannst die Wahl deiner Hauptseele später nicht mehr ändern!'|trans({},'soul') }}</p>
                        <p><b>{{ 'Da du bereits Punkte auf MyHordes gesammelt hast, kannst du nicht länger Seelenpunkte, Auszeichnungen und Heldenerfahrung von einer importierten Seele übernehmen.'|trans({},'soul') }}</b></p>
                    {% else %}
                        <p>{{ 'Seelenpunkte, Auszeichnungen und Heldenerfahrung können nur von einer Seele importiert werden - deiner Hauptseele. Überlege dir deine Entscheidung gut, denn du kannst die Wahl deiner Hauptseele später nicht mehr ändern!'|trans({},'soul') }}</p>
                    {% endif %}

                    {% if preview %}
                        <p>{{ 'Du musst diese Entscheidung nicht jetzt treffen, sondern kannst diese Seele auch nachträglich noch zu deiner Hauptseele erklären - solange du inzwischen nicht bereits eine andere Seele als Hauptseele gewählt hast.'|trans({},'soul') }}</p>
                        <label><input type="checkbox" id="chk_make_main"> {{ 'Diese Seele zu meiner Hauptseele machen!'|trans({},'soul') }}</label>
                    {% else %}
                        <p>{{ 'Um diese Seele zu deiner Hauptseele zu machen, verwende die Schaltfläche auf der vorherigen Seite.'|trans({},'soul') }}</p>
                    {% endif %}

                    <p>{{ 'Unabhängig davon, ob du diese Seele zu deiner Hauptseele machst oder nicht, kannst du ihre Daten bei Bedarf selbstverständlich erneut mit Twinoid abgleichen und ihre Daten aktualisieren.'|trans({},'soul') }}</p>


                {% endif %}
            </div>

            <div class="dashboard" x-only-main="1" {% if not main_soul %}disabled="disabled"{% endif %}>
                <div class="row">
                    <div class="padded cell rw-4 rw-lg-12 center">
                        <div class="counter">{{ '{c} Seelenpunkte'|trans({'{c}': payload.summarySoulPoints}, 'soul') }}</div>
                    </div>
                    <div class="padded cell rw-4 rw-lg-12 center">
                        {% if payload.pictos|length > 0 %}
                            {% set num     = 0 %}
                            {% set rare    = 0 %}
                            {% set lame    = 0 %}
                            {% set unknown = 0 %}
                            {% for picto in payload.pictos %}
                                {% set num = num + picto.count %}
                                {% if not picto.convertPicto %}
                                    {% set unknown = unknown+1 %}
                                {% elseif picto.convertPicto.rare %}
                                    {% set rare = rare+1 %}
                                {% else %}
                                    {% set lame = lame+1 %}
                                {% endif %}
                            {% endfor %}

                            <div class="counter">{{ '{c} Auszeichnungen'|trans({'{c}': num}, 'soul') }}</div>
                            {% if rare > 0 %}
                                <div><em>{{ '{c} Auszeichnungs-Typen, {cc} davon selten'|trans({'{c}': payload.pictos|length, '{cc}': rare},'soul') }}</em></div>
                            {% else %}
                                <div><em>{{ '{c} Auszeichnungs-Typen'|trans({'{c}': payload.pictos|length},'soul') }}</em></div>
                            {% endif %}
                            {% if unknown > 0 %}
                                <div><em><img alt="" src="{{ asset('build/images/icons/small_warning.gif') }}" /> {{ '{num} unbekannte Auszeichnungen!'|trans({'{num}': unknown},'soul') }}</em></div>
                            {% endif %}
                        {% else %}
                            <div class="counter">{{ 'Keine Auszeichnungen'|trans({}, 'soul') }}</div>
                        {% endif %}
                    </div>
                    <div class="padded cell rw-4 rw-lg-12 center">
                        <div class="counter">{{ '{c} Tage als Held'|trans({'{c}': payload.summaryHeroDays}, 'soul') }}</div>
                        {% if payload.summaryHeroDays > 0 or payload.pastTowns|length > 0 %}
                            <div><em>{{ 'Dieser Wert ist geschätzt und kann vom tatsächlichen Wert abweichen. Dies lässt sich leider nicht vermeiden.'|trans({},'soul') }}</em></div>
                        {% endif %}
                    </div>
                </div>
            </div>

            {% if payload.pastTowns|length > 0 %}
                <h5>{{ 'Vergangene Städte'|trans({},'soul') }}</h5>
                {% if preview %}
                    <div class="help">
                        {{ 'Hier werden die Städte angezeigt, die du in der vergangenheit gespielt hast. Wenn du dich aktuell in einer Stadt befindest, wird diese hier nicht angezeigt und auch nicht importiert.'|trans({},'soul') }}
                    </div>
                {% endif %}
                <div class="note">
                    {% set town_num = 0 %}
                    <div class="row-table" id="data_towns">
                        <div class="row header">
                            <div class="padded cell rw-1 hide-md hide-sm">{{ 'Saison'|trans({},'soul') }}</div>
                            <div class="padded cell rw-1 rw-sm-2">{{ 'Tag'|trans({},'soul') }}</div>
                            <div class="padded cell rw-4 rw-sm-8">{{ 'Stadtname'|trans({},'soul') }}</div>
                            <div class="padded cell rw-5 hide-sm">{{ 'Infos'|trans({},'soul') }}</div>
                            <div class="padded cell rw-1 rw-md-2">{{ 'Punkte'|trans({},'soul') }}</div>
                        </div>
                        {% for town in payload.pastTowns %}
                            {% set town_num = town_num + 1 %}
                            <div class="row {% if town_num > 5 %}hidden{% endif %}">
                                <div class="padded cell rw-1 hide-md hide-sm">{{ town.season }}</div>
                                <div class="padded cell rw-1 rw-sm-2">{{ town.day }}</div>
                                <div class="padded cell rw-4 rw-sm-8">{{ town.name }}</div>
                                <div class="padded cell rw-5 hide-sm">
                                    {% if town.death != 0 %}
                                        <div>
                                            {{ 'Todesart'|trans({},'soul') }}:
                                            <i class="small">
                                                {{ town.convertDeath.label|trans({},'game') }}
                                                {% if town.convertDeath.ref == 0 %}
                                                    ({{ town.death }})
                                                {% endif %}
                                            </i>

                                        </div>
                                    {% endif %}
                                    {% if town.day != town.survivedDays %}
                                        <div>{{ 'Überlebt'|trans({},'soul') }}: <i class="small">{{ '{d} Tage'|trans({'{d}': town.survivedDays},'soul') }}</i></div>
                                    {% endif %}
                                    {% if town.message is not empty %}
                                        <div>{{ 'Letzte Worte'|trans({},'soul') }}: <i class="small">"{{ town.message }}"</i></div>
                                    {% endif %}
                                    {% if town.comment is not empty %}
                                        <div>{{ 'Kommentar'|trans({},'soul') }}: <i class="small">"{{ town.comment }}"</i></div>
                                    {% endif %}
                                </div>
                                <div class="padded cell rw-1 rw-md-2">{{ town.score }}</div>
                            </div>
                        {% endfor %}
                    </div>
                    {% if town_num > 5 %}
                        <div class="center"><span id="more_towns_btn" class="small pointer">{{ 'Mehr anzeigen'|trans({},'global') }}</span></div>
                    {% endif %}
                </div>
            {% endif %}

            {% if payload.pictos|length > 0 %}
                <h5>{{ 'Auszeichnungen'|trans({},'soul') }}</h5>
                {% if preview %}
                    <div class="help">
                        {{ 'Hier werden dir die Auszeichnungen angezeigt, welche du im Laufe der Zeit verdient hast.'|trans({},'soul') }}
                        {% if not main_soul %}
                            <p x-only-main="1" class="critical"><img src="{{ asset('build/images/icons/small_warning.gif') }}" alt="!"> {{ 'Diese Daten können nur von deiner Hauptseele importiert werden.'|trans({},'soul') }}</p>
                        {% endif %}
                    </div>
                {% elseif not main_soul %}
                    <div class="help">
                        <p class="critical"><img src="{{ asset('build/images/icons/small_warning.gif') }}" alt="!"> {{ 'Diese Daten können nur von deiner Hauptseele importiert werden.'|trans({},'soul') }}</p>
                    </div>
                {% endif %}
                <div class="note">
                    {% set picto_num = 0 %}
                    <div class="row-table" id="data_pictos">
                        <div class="row header">
                            <div class="padded cell rw-6 rw-lg-7 rw-md-8 rw-sm-10">{{ 'Auszeichnung'|trans({},'soul') }}</div>
                            <div class="padded cell rw-6 rw-lg-5 rw-md-4 rw-sm-2 ">{{ 'Anzahl'|trans({},'soul') }}</div>
                        </div>
                        {% for picto in payload.pictos %}
                            {% set picto_num = picto_num + 1 %}
                            <div class="row {% if picto_num > 5 %}hidden{% endif %}">
                                <div class="padded cell rw-6 rw-lg-7 rw-md-8 rw-sm-10">
                                    {# @var pp \App\Entity\PictoPrototype #}
                                    {% set pp = picto.convertPicto %}
                                    {% if pp %}
                                        <img alt="" src="{{ asset('build/images/pictos/' ~ pp.icon ~ '.gif') }}" />
                                        {{ pp.label|trans({},'game') }}
                                    {% else %}
                                        <b>{{ 'Unbekannte Auszeichnung'|trans({},'soul') }}</b><br /><i class="small">"{{ picto.name }}" - {{ picto.id }}</i>
                                    {% endif %}
                                </div>
                                <div class="padded cell rw-6 rw-lg-5 rw-md-4 rw-sm-2">
                                    {{ picto.count }}
                                </div>
                            </div>
                        {% endfor %}
                    </div>
                    {% if picto_num > 5 %}
                        <div class="center"><span id="more_pictos_btn" class="small pointer">{{ 'Mehr anzeigen'|trans({},'global') }}</span></div>
                    {% endif %}
                </div>
            {% endif %}

            {% if payload.unlockables|length > 0 %}
                <h5>{{ 'Freischaltbares'|trans({},'soul') }}</h5>
                {% if preview %}
                    <div class="help">
                        {{ 'Hier siehst du deine Titel und Icons.'|trans({},'soul') }}
                    </div>
                {% endif %}
                <div class="note">
                    {% set ach_num = 0 %}
                    <div class="row-table" id="data_ach">
                        <div class="row header">
                            <div class="padded cell rw-1 rw-md-2 hide-sm">{{ 'Typ'|trans({},'soul') }}</div>
                            <div class="padded cell rw-4 rw-md-5 rw-sm-6">{{ 'Name & Infos'|trans({},'soul') }}</div>
                            <div class="padded cell rw-4 rw-md-5 rw-sm-6">{{ 'Wert'|trans({},'soul') }}</div>
                            <div class="padded cell rw-3 hide-md hide-sm">{{ 'Datum'|trans({},'soul') }}</div>
                        </div>
                        {% for ach in payload.unlockables %}
                            {% set ach_num = ach_num + 1 %}
                            <div class="row {% if ach_num > 5 %}hidden{% endif %}">
                                <div class="padded cell rw-1 rw-md-2 hide-sm">{{ ach.niceType|trans({},'soul') }}</div>
                                <div class="padded cell rw-4 rw-md-5 rw-sm-6">
                                    <div>{{ ach.name }}</div>
                                    {# @var pp \App\Entity\PictoPrototype #}
                                    {% set pp = ach.convertPicto %}
                                    {% if pp %}
                                        <div class="small">
                                            <img alt="" src="{{ asset('build/images/pictos/' ~ pp.icon ~ '.gif') }}" />
                                            {{ pp.label|trans({},'game') }} x <b>{{ ach.count }}</b>
                                        </div>
                                    {% endif %}
                                </div>
                                <div class="padded cell rw-4 rw-md-5 rw-sm-6">
                                    {% if ach.type == 'icon' %}
                                        <img src="{{ ach.data }}" alt="" />
                                    {% else %}
                                        <b>{{ ach.data }}</b>
                                    {% endif %}
                                </div>
                                <div class="padded cell rw-3 hide-md hide-sm">{{ ach.date|format_datetime('medium', 'medium') }}</div>
                            </div>
                        {% endfor %}
                    </div>
                    {% if ach_num > 5 %}
                        <div class="center"><span id="more_ach_btn" class="small pointer">{{ 'Mehr anzeigen'|trans({},'global') }}</span></div>
                    {% endif %}
                </div>
            {% endif %}


            <div class="row">
                {% if preview %}
                    <div class="cell padded rw-4 rw-sm-12">
                        <button id="begin_import_can_btn">{{ 'Abbrechen'|trans({},'global') }}</button>
                    </div>
                    <div class="cell padded rw-4 ro-4 ro-sm-0 rw-sm-12">
                        <button id="begin_import_con_btn">{{ 'Import bestätigen'|trans({},'soul') }}</button>
                    </div>
                {% else %}
                    <div class="cell padded rw-4 rw-sm-12">
                        <button x-ajax-href="{{ path('soul_import') }}" >{{ 'Zurück'|trans({},'global') }}</button>
                    </div>
                {% endif %}
            </div>
        </div>
    </div>
{% endblock %}
{% block js %}
    {{ parent() }}
    <script>
        {% if preview %}
            document.getElementById('begin_import_can_btn').addEventListener('click', function() {
                $.ajax.easySend( '{{ path('soul_import_cancel_api') }}', {},
                    function () {
                        $.ajax.load(null, '{{ path('soul_settings') }}', true);
                    } )
            });

            document.getElementById('begin_import_con_btn').addEventListener('click', function() {
                const set_as_main = {% if select_main_soul %}document.getElementById('chk_make_main').checked{% else %}false{% endif %};

                if (set_as_main && !confirm('{{ 'Bist du sicher, dass du diese Seele als deine Hauptseele festlegen willst. Dieser Vorgang kann nicht rückgängig gemacht werden!'|trans({},'soul')|e('js') }}'))
                    return;

                $.ajax.easySend( '{{ path('soul_import_confirm_api') }}', {main: set_as_main},
                    function () {
                        $.html.notice( '{{ 'Deine Seele wurde erfolgreich importiert!'|trans({},'soul')|e('js') }}' )
                        $.ajax.load(null, '{{ path('soul_settings') }}', true);
                    } )
            });

            {% if select_main_soul and not limited %}
                document.getElementById('chk_make_main').addEventListener('change', function() {
                    if (document.getElementById('chk_make_main').checked)
                        $.html.forEach('[x-only-main]', element => { if (element.classList.contains('dashboard')) element.removeAttribute('disabled'); else element.classList.add('hidden') } );
                    else $.html.forEach('[x-only-main]', element => { if (element.classList.contains('dashboard')) element.setAttribute('disabled','disabled'); else element.classList.remove('hidden') } );
                })
            {% endif %}
        {% endif %}

        let town_more_btn = document.getElementById('more_towns_btn');
        if (town_more_btn) town_more_btn.addEventListener('click', function() {
            let town_list = document.getElementById( 'data_towns' );
            if (!town_list) return;
            let hidden_entries = town_list.querySelectorAll('.row.hidden');
            for (let i = 0; i < Math.min(50,hidden_entries.length); i++)
                hidden_entries[i].classList.remove('hidden');
            if (hidden_entries.length <= 50)
                town_more_btn.classList.add('hidden');
        });

        let picto_more_btn = document.getElementById('more_pictos_btn');
        if (picto_more_btn) picto_more_btn.addEventListener('click', function() {
            let picto_list = document.getElementById( 'data_pictos' );
            if (!picto_list) return;
            let hidden_entries = picto_list.querySelectorAll('.row.hidden');
            for (let i = 0; i < Math.min(50,hidden_entries.length); i++)
                hidden_entries[i].classList.remove('hidden');
            if (hidden_entries.length <= 50)
                picto_more_btn.classList.add('hidden');
        });

        let ach_more_btn = document.getElementById('more_ach_btn');
        if (ach_more_btn) ach_more_btn.addEventListener('click', function() {
            let ach_list = document.getElementById( 'data_ach' );
            let hidden_entries = ach_list.querySelectorAll('.row.hidden');
            for (let i = 0; i < Math.min(50,hidden_entries.length); i++)
                hidden_entries[i].classList.remove('hidden');
            if (hidden_entries.length <= 50)
                ach_more_btn.classList.add('hidden');
        });

    </script>
{% endblock %}